
//Title:        Gravity Wars for Java
//Version:      
//Copyright:    Copyright (c) 1999
//Author:       Giovanni Beltrame
//Company:      Rollercrew
//Description:  Very addictive space game
package GravityWars;

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.util.Vector;
import java.util.StringTokenizer;

public class Fader
{

	// Passo di variazione del colore
	int deltaR,deltaG,deltaB;

	// Colore iniziale, finale e corrente
	int R,G,B;
	int finalR,finalG,finalB;
	int initR,initG,initB;

	// Contatore del testo corrente
	int curr = 0;

	// Boolean che indica il raggiungimento del foreground color
	boolean max = false;
	
	// Vettore contenente le scritte
	Vector scritte = new Vector();

	// Vettore contenente i font
	Vector fonts = new Vector();

	// Vettore contenente gli URL
	Vector urls = new Vector();

	// Vettore contenente le immagini
	Vector immagini = new Vector();

	public Fader( int[] background , int[] foreground ) throws IllegalArgumentException {
		if( background.length < 3 || background.length < 3 )
			throw new IllegalArgumentException( "Colori non definiti!" );
		
			R = initR = background[0]; G = initG = background[1]; B = initB = background[2];
			finalR = foreground[0]; finalG = foreground[1]; finalB = foreground[2];	
			deltaR = deltaG = deltaB = 1;
	}

	public Fader() {
		R = G = B = 0;
		initR = initG = initB = 0;
		finalR = finalG = finalB = 255;
		deltaR = deltaG = deltaB = 1;
	}

	public void setBackground( int i , int j , int k ) {
		R= initR = i; G= initG = j ; B=initB = k;

	}

	public void setForeground( int i , int j , int k ) {
		finalR = i ; finalG = j ; finalB = k ;
	}

	public void setDelta( int i ) {
		if( initR < finalR )
			deltaR = i;
		else if( initR == finalR )
			deltaR = 0;
		else 
			deltaR = -i;
		if( initG < finalG )
			deltaG = i;
		else if( initG == finalG )
			deltaG = 0;
		else
			deltaG = -i;
		if( initB < finalB )
			deltaB = i;
		else if( initB == finalB )
			deltaB = 0;
		else 
			deltaB = -i;
	}

	public void addText( String s , Font f , URL u , Image i) {
		scritte.addElement(s);
		fonts.addElement(f);
		urls.addElement(u);
		immagini.addElement(i);
	}

	public void next() {
		if( curr < scritte.size()-1 ) curr++;
		else curr = 0;
	}

	public int changeColors() {
		int pausa = 1;

		if( !max ) {
			R += deltaR;
			G += deltaG;
			B += deltaB;
			if( !( ( R < finalR && deltaR > 0) || (deltaR <0 && R > finalR ) ) )
				R = finalR;
			if( !(( G < finalG && deltaG > 0) || (deltaG <0 && G > finalG )))
				G = finalG;
			if( !(( B < finalB && deltaB > 0) || (deltaB <0 && B > finalB )))
				B = finalB;
			if( R == finalR && G == finalG && B == finalB ){
				max = true;
				pausa = 30;
			}
		} else {
			R -= deltaR;
			G -= deltaG;
			B -= deltaB;
			if( !( (R < initR && deltaR < 0) || (deltaR > 0 && R > initR )))
				R = initR;
			if( !( (G < initG && deltaG < 0) || (deltaG > 0 && G > initG )))
				G = initG;
			if( !( (B < initB && deltaB < 0) || (deltaB > 0 && B > initB )))
				B = initB;
			if( R == initR && G == initG && B == initB ){
				max = false;
				pausa = 30;
				next();
			}
		}	
		return pausa;
	}
	
	public void draw( Container container , Graphics g ) {
		Font f = (Font) fonts.elementAt( curr );
		FontMetrics fm = container.getFontMetrics( f );
		Image i = (Image) immagini.elementAt(curr);
		String t = (String) scritte.elementAt(curr);

		g.drawImage( i , 0 , (container.getSize().height - i.getHeight(container))/2 , container );

		g.setFont( (Font) fonts.elementAt(curr) );
		g.setColor( new Color( R , G , B ) );

		g.drawString( t , (container.getSize().width - fm.stringWidth(t) + i.getWidth(container))/2,
						 (container.getSize().height + fm.getAscent() )/2);
	}

	public URL getURL() {
		return (URL) urls.elementAt(curr);
	}

}

